//#include "metalShaderTypes.h"

typedef struct
{
	int direction;
} fxVars;

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]],constant fxVars& vars[[ buffer(2)]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
	out.normPos=in[vertexID].pos.xy*vec2(.5,.5f)+vec2(.5,.5);
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]]
							 ,constant fxVars& vars[[ buffer(1)]])
{
	float x1 = u.transitionProgressLinear;
	vec2 p1 = in.tex1;
	vec2 p2 = in.tex1;

	float x2=smoothstep(.20,.80,(x1*2.0+p1.x-1.0));
	x1=smoothstep(.20,.80,(x1*2.0+p1.x-1.0));

	vec2 tc1=(p1-.5)*(1.-x1)+.5;
	vec2 tc2=(p2-.5)*(1.-x2)+.5;

	tc1=(p1-.5)*x1+.5;
	
	vec4 texColor;
	if(u.transitionState==2)
		texColor=tex(inputTex0,tc2);
	else
		texColor=tex(inputTex0,tc1);
	
	vec4 colorA=mix(vec4(0,0,0,0),texColor,u.mix);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),u.mix);
	float4 outColor=mix(colorB,colorA,u.transitionProgressLinear);
	
#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif

	return outColor;
}
